/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#pragma once

//
// A C++ class for subclassing a window without any other framework:
//

class SubclassedWindow
{
	public:
								SubclassedWindow(HWND hwnd);
		virtual 				~SubclassedWindow();

	protected:
		const HWND				Hwnd;
		WNDPROC 				fOldWndProc;

		static LRESULT CALLBACK StaticWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
		virtual LRESULT 		WndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam) = 0;
};


// This class implements the hyperlink functionality.  The idea is
// quite simple: Draw the static text in the appropriate color.  When the
// user clicks in the control window, call ShellExecute with appropriate
// parameters to launch the URL.  Change the color after a successful
// browser launch.	This code grabs the URL right out of the window text.
// ShellExecute will understand both http: and mailto: URLs.

class StaticHyperlink: public SubclassedWindow
{
	public:
								StaticHyperlink(HWND hwnd);
		virtual 				~StaticHyperlink();

		HBRUSH					OnCtlColorStatic(HWND parent, HDC dc, HWND control, int type);
		void					OnLButtonDown(HWND hwnd, BOOL doubleclick, int x, int y, UINT flags);
		UINT					OnNcHitTest(HWND hwnd, int x, int y);
		BOOL					OnSetCursor(HWND hwnd, HWND hwndCursor, UINT codeHitTest, UINT msg);

	private:
		HFONT					font;
		HCURSOR 				finger;
		COLORREF				color;

		virtual LRESULT 		WndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
};

